--- old/usr/src/cmd/svc/startd/method.c	Mon Dec  4 17:58:49 2017
+++ new/usr/src/cmd/svc/startd/method.c	Mon Dec  4 17:58:49 2017
@@ -1169,7 +1169,7 @@
 
 	r = method_run(&inst, info->sf_method_type, &exit_code);
 
-	if (r == 0 && exit_code == 0) {
+	if (r == 0 && (exit_code == 0 || exit_code == SMF_EXIT_MON_DEGRADE)) {
 		/* Success! */
 		assert(inst->ri_i.i_next_state != RESTARTER_STATE_NONE);
 
@@ -1187,7 +1187,18 @@
 			else
 				method_remove_contract(inst, B_TRUE, B_TRUE);
 		}
+
 		/*
+		 * When a start method returns with SMF_EXIT_MON_DEGRADE we
+		 * transition the service into degraded.
+		 */
+		if (info->sf_method_type == METHOD_START &&
+		    exit_code == SMF_EXIT_MON_DEGRADE) {
+			inst->ri_i.i_next_state = RESTARTER_STATE_DEGRADED;
+			info->sf_reason = restarter_str_method_failed;
+		}
+
+		/*
 		 * We don't care whether the handle was rebound because this is
 		 * the last thing we do with it.
 		 */
